if (!$AJ::addedRemap)
{
	$remapDivision[$remapCount] = "Auto-Jet";
	$remapName[$remapCount] = "Activate/Deacticate";
	$remapCmd[$remapCount] = "activateJet";
	$remapCount++;
	$remapName[$remapCount] = "Toggle Lateral Fixing";
	$remapCmd[$remapCount] = "autoJetToggleLateral";
	$remapCount++;
	$AJ::addedRemap = 1;
}

function autoJetToggleLateral(%val)
{
	if(%val) return;
	
	if($AJ::horizontalUnlock)
	{
		$AJ::x = getWord(ServerConnection.getControlObject().getTransform(), 0);
		$AJ::y = getWord(ServerConnection.getControlObject().getTransform(), 1);
		moveBackward(0);
		moveForward(0);
		moveLeft(0);
		moveRight(0);
		$AJ::horizontalUnlock = 0;
	}
	else
	{
		$AJ::horizontalUnlock = 1;
		moveBackward(0);
		moveForward(0);
		moveLeft(0);
		moveRight(0);
	}
}

function autoJet()
{
    cancel($AJ::JetTick);

    if (!isObject(ServerConnection))
	{
		deactivateJet();
        return;
	}

    %control = serverConnection.getControlObject();

    if (!isObject(%control))
	{
		// echo("FIX YOUR AUTOJET YOU IDIOT");
        return;
	}

    %CP_x = getWord(%control.getPosition(), 0);
    %CP_y = getWord(%control.getPosition(), 1);
    %CP_z = getWord(%control.getPosition(), 2);
    %CV_x = getWord(%control.getVelocity(), 0);
    %CV_y = getWord(%control.getVelocity(), 1);
    %CV_z = getWord(%control.getVelocity(), 2);
	
    %CF_x = getWord(%control.getForwardVector(), 0);
    %CF_y = getWord(%control.getForwardVector(), 1);
	
    %DA_x = ($AJ::x - %CP_x - %CV_x);
    %DA_y = ($AJ::y - %CP_y - %CV_y);
    %DA_z = ($AJ::z - %CP_z - %CV_z);
	
	if(%control.getWaterCoverage() >= 0.65)
	{
		//underwater
		$AJ::crouching = 1;
		
		if (%curVel < -1)
		{
			crouch(0);
		}
		else if (%heightDif <= 0.2)
		{
			crouch(%DA_z < 0);
		}
		if ($AJ::jetting)
		{
			jet(0);
			$AJ::jetting = 0;
		}
	}
	else
	{
		//not underwater
		$AJ::jetting = 1;
		crouch(0);
		
		if (%curVel < -1)
		{
			jet(1);
		}
		else
		{
			jet(%DA_z > 0);
		}
		if ($AJ::crouching)
		{
			crouch(0);
			$AJ::crouching = 0;
		}
	}
	
	if(!$AJ::horizontalUnlock)
	{
		// transform desired velocity to player-perspective
		%DPV_x = %CF_x * %DA_y - %CF_y * %DA_x;
		%DPV_y = %CF_x * %DA_x + %CF_y * %DA_y;
		
		if(%DPV_x >  0.25) %DPV_x =  0.25;
		if(%DPV_x < -0.25) %DPV_x = -0.25;
		if(%DPV_y >  0.25) %DPV_y =  0.25;
		if(%DPV_y < -0.25) %DPV_y = -0.25;
		
		if(%DPV_x > 0)
		{
			moveLeft(%DPV_x);
			moveRight(0);
		}
		else
		{
			moveLeft(0);
			moveRight(-%DPV_x);
		}
		
		if(%DPV_y > 0)
		{
			moveForward(%DPV_y);
			moveBackward(0);
		}
		else
		{
			moveForward(0);
			moveBackward(-%DPV_y);
		}
	}
	
    $AJ::JetTick = schedule(32, 0, autoJet);
}

function activateJet(%val)
{
	if (!%val) return;

	if (!isEventPending($AJ::JetTick))
	{
		if (!isObject(ServerConnection))
			return;

		if (!isObject(ServerConnection.getControlObject()))
		{
			echo("FIX YOUR AUTOJET YOU IDIOT");
			return;
		}
		else
		{
			$AJ::x = getWord(ServerConnection.getControlObject().getTransform(), 0);
			$AJ::y = getWord(ServerConnection.getControlObject().getTransform(), 1);
			$AJ::z = getWord(ServerConnection.getControlObject().getTransform(), 2);
			$AJ::JetTick = schedule(0, 0, "autoJet");		
		}
	}
	else
	{
		deactivateJet();
	}
}

function deactivateJet()
{
	if (isEventPending($AJ::JetTick))
	{
		cancel($AJ::JetTick);
		crouch(0);
		jet(0);
		moveBackward(0);
		moveForward(0);
		moveLeft(0);
		moveRight(0);
	}
}

deactivatePackage(autoJetPackage);

package autoJetPackage
{
	function jet(%val)
	{
		if(isEventPending($AJ::JetTick) && $AJ::jetting)
			return;
		Parent::jet(%val);
	}
	
	function crouch(%val)
	{
		if(isEventPending($AJ::JetTick))
		{
			$AJ::Z -= 0.5;
			return;
		}
		Parent::crouch(%val);
	}
	
	function jump(%val)
	{
		if(isEventPending($AJ::JetTick))
		{
			$AJ::Z += 0.5;
			return;
		}
		Parent::jump(%val);
	}
	
	function moveForward(%val)
	{
		if(isEventPending($AJ::JetTick) && !$AJ::horizontalUnlock)
			return;
		Parent::moveForward(%val);
	}
	
	function moveBackward(%val)
	{
		if(isEventPending($AJ::JetTick) && !$AJ::horizontalUnlock)
			return;
		Parent::moveBackward(%val);
	}
	
	function moveLeft(%val)
	{
		if(isEventPending($AJ::JetTick) && !$AJ::horizontalUnlock)
			return;
		Parent::moveLeft(%val);
	}
	
	function moveRight(%val)
	{
		if(isEventPending($AJ::JetTick) && !$AJ::horizontalUnlock)
			return;
		Parent::moveRight(%val);
	}
};

activatePackage(autoJetPackage);



//????
//function findJetPlayer(%playername)
//{
//	if (%playername $= "")
//	{
//		%player = ServerConnection.getControlObject();
//		%type = %player.getClassName();
//		if (%type $= "Player" || %type $= "AIPlayer") return %player;
//		else return 0;
//	}
//	
//	for (%i = 0; %i < ServerConnection.getCount(); %i++)
//	{
//		%testObj = ServerConnection.getObject(%i);
//		if (%testObj.getClassName() $= "Player")
//		{
//			if (%testObj.getShapeName() $= $pref::Player::NetName)
//			{
//				%player = %testObj;
//				return %player;
//			}
//		}
//	}
//	return 0;
//}